"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createVerifyAppProxyMiddleware = void 0;
var shopify_verify_app_proxy_1 = require("shopify-verify-app-proxy");
var createVerifyAppProxyMiddleware = function (shopifyAPISecret) {
    return function (req, _, next) {
        var _a;
        var _b = req.query, signature = _b.signature, rest = __rest(_b, ["signature"]);
        var data = (0, shopify_verify_app_proxy_1.transformRecordToSortedKeyValueString)(rest);
        var verified = (0, shopify_verify_app_proxy_1.verifyAppProxySignature)((_a = signature) !== null && _a !== void 0 ? _a : "", shopifyAPISecret, data);
        if (!verified)
            throw new Error("The requested endpoint is not allowed. Invalid signature.");
        next();
    };
};
exports.createVerifyAppProxyMiddleware = createVerifyAppProxyMiddleware;
